/*
 *     gtkatlantic - the gtk+ monopd client, enjoy network monopoly games
 *
 *
 *  Copyright (C) 2002 Rochet Sylvain
 *
 *  gtkatlantic is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#include "config.h"

#include "global.h"
#include "interface.h"
#include "callback.h"
#include "game.h"
#include "main.h"
#include "client.h"

#include "engine.h"

#include "icon.xpm"

void interface_create_mainwindow()  {

	GdkPixmap *pixmap;
	GdkBitmap *mask;

	global->MainWin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(global->MainWin), "GtkAtlantic");
	gtk_window_set_policy(GTK_WINDOW(global->MainWin), FALSE, FALSE, TRUE);
	gtk_widget_set_usize(global->MainWin, 700, 500);

	gtk_signal_connect(GTK_OBJECT(global->MainWin), "delete-event", (GtkSignalFunc)gtk_exit, NULL);
	gtk_signal_connect(GTK_OBJECT(global->MainWin), "destroy", (GtkSignalFunc)gtk_exit, NULL);

	global->MainBox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(global->MainWin), global->MainBox);

	/* icon */
	gtk_widget_realize(global->MainWin);
	pixmap = gdk_pixmap_create_from_xpm_d(global->MainWin->window, &mask, NULL, icon_xpm);
	gdk_window_set_icon(global->MainWin->window, NULL, pixmap, mask);

	/* used for reparent some widgets shouldn't be displayed */
	global->Trick = gtk_vbox_new(FALSE, 0);

	gtk_widget_show_all(global->MainWin);
}


void interface_create_menubar()  {

//	GtkWidget *HandleBar;
		GtkWidget *MenuBar;
			GtkWidget *Button;
				GtkWidget *Menu;
					GtkWidget *MenuItem;

//	HandleBar = gtk_handle_box_new();
//	gtk_box_pack_start(GTK_BOX(global->MainBox), HandleBar, FALSE, FALSE, 0);

	MenuBar = gtk_menu_bar_new();
//	gtk_container_add(GTK_CONTAINER(HandleBar), MenuBar);
	gtk_box_pack_start(GTK_BOX(global->MainBox), MenuBar, FALSE, FALSE, 0);

	/* GAME MENU */
	Button = gtk_menu_item_new_with_label("Game");

	gtk_menu_bar_append(GTK_MENU_BAR(MenuBar), Button);
//	gtk_signal_connect(GTK_OBJECT(Button), "activate", (GtkSignalFunc)CallBack, (gpointer)"Menu Game");
   
	Menu = gtk_menu_new();
	gtk_menu_set_title(GTK_MENU(Menu), "Game Menu");
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(Button), Menu);

	MenuItem = gtk_tearoff_menu_item_new();
	gtk_menu_append(GTK_MENU(Menu), MenuItem);

	MenuItem = gtk_menu_item_new_with_label("Un/Dock Server Messages");
	gtk_menu_append(GTK_MENU(Menu), MenuItem);
	gtk_signal_connect(GTK_OBJECT(MenuItem), "activate", (GtkSignalFunc)CallBack_toggle_float_message, NULL);

	MenuItem = gtk_menu_item_new_with_label("Un/Dock Chat");
	gtk_menu_append(GTK_MENU(Menu), MenuItem);
	gtk_signal_connect(GTK_OBJECT(MenuItem), "activate", (GtkSignalFunc)CallBack_toggle_float_chat, NULL);

	MenuItem = gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(Menu), MenuItem);

	MenuItem = gtk_menu_item_new_with_label("Exit");
	gtk_menu_append(GTK_MENU(Menu), MenuItem);
	gtk_signal_connect(GTK_OBJECT(MenuItem), "activate", (GtkSignalFunc)gtk_exit, NULL);

	/* HELP MENU */
	Button = gtk_menu_item_new_with_label("Help");
	gtk_menu_item_right_justify(GTK_MENU_ITEM(Button));
   
	gtk_menu_bar_append(GTK_MENU_BAR(MenuBar), Button);
//	gtk_signal_connect(GTK_OBJECT(Button), "activate", (GtkSignalFunc)CallBack, (gpointer)"Menu Help");

	Menu = gtk_menu_new();
	gtk_menu_set_title(GTK_MENU(Menu), "Help Menu");
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(Button), Menu);

	MenuItem = gtk_tearoff_menu_item_new();
	gtk_menu_append(GTK_MENU(Menu), MenuItem);

	MenuItem = gtk_menu_item_new_with_label("About");
	gtk_menu_append(GTK_MENU(Menu), MenuItem);
	gtk_signal_connect(GTK_OBJECT(MenuItem), "activate", (GtkSignalFunc)interface_create_aboutwin, NULL);

//	gtk_widget_show_all(HandleBar);
	gtk_widget_show_all(MenuBar);
}


void interface_create_logo()  {

//global->MainBox
	//global->MainVerticalBox
		GtkWidget *FrameLogo;
			GtkWidget *AlignementLogo;
				//global->gdkrgb_logo
				//global->pixmap_logo
				//global->mask_logo
		GtkWidget *AlignementEnterButton;
			GtkWidget *EnterButton;

	guint32 frame, pic;

	GtkStyle *style;
	GdkColor gdk_color;
	guint32  bg_color;

	global->MainVerticalBox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(global->MainBox), global->MainVerticalBox, TRUE, TRUE, 0);

	/* logo */
	AlignementLogo = gtk_alignment_new(0.5, 0.5, 0.0, 0.0);
	gtk_box_pack_start(GTK_BOX(global->MainVerticalBox), AlignementLogo, TRUE, TRUE, 0);

	FrameLogo = gtk_frame_new(NULL);
	gtk_container_add(GTK_CONTAINER(AlignementLogo), FrameLogo);

	global->gdkrgb_logo = gtk_drawing_area_new();
	gtk_drawing_area_size( GTK_DRAWING_AREA (global->gdkrgb_logo), data->logo_width +20, data->logo_height +20);
	gtk_container_add(GTK_CONTAINER(FrameLogo), global->gdkrgb_logo);
	gtk_signal_connect (GTK_OBJECT ( global->gdkrgb_logo), "expose_event", GTK_SIGNAL_FUNC (on_logo_expose), NULL);

	/* enter button */
	AlignementEnterButton = gtk_alignment_new(0.9, 0.5, 0.0, 0.0);
	gtk_widget_set_usize(AlignementEnterButton, 0, 100);
	gtk_box_pack_start(GTK_BOX(global->MainVerticalBox), AlignementEnterButton, FALSE, FALSE, 0);

	EnterButton = gtk_button_new_with_label("Enter");
	gtk_widget_set_usize(EnterButton, 150, 30);
	gtk_container_add(GTK_CONTAINER(AlignementEnterButton), EnterButton);
	gtk_signal_connect(GTK_OBJECT(EnterButton), "clicked", (GtkSignalFunc)Callback_EnterButton, NULL);

	/* get background color */
	style = gtk_widget_get_style(FrameLogo);
	gdk_color = style->bg[0];
	bg_color = (gdk_color.red >> 8) << 16 | (gdk_color.green >> 8) << 8 | (gdk_color.blue >> 8);

	/* frame */
	frame = global->logo_frame = frame_create();
	frame_set_width(frame, data->logo_width + 20);
	frame_set_height(frame, data->logo_height + 20);
	frame_set_bgcolor(frame, bg_color);

	/* logo alpha */
	pic = global->logo_alpha = pic_create(frame);
	pic_is_alphamask(frame, pic);
	pic_set_width(frame, pic, data->logo_width);
	pic_set_height(frame, pic, data->logo_height);
	pic_buff(frame, pic, data->pngfile_logo_alpha);

	/* logo */
	pic = global->logo_pic = pic_create(frame);
	pic_set_x(frame, pic, 0);
	pic_set_y(frame, pic, 0);
	pic_set_z(frame, pic, 0);	pic_set_width(frame, pic, data->logo_width);
	pic_set_height(frame, pic, data->logo_height);
	pic_set_alphamask(frame, pic, global->logo_alpha);
	pic_buff(frame, pic, data->pngfile_logo_image);

	gtk_widget_show_all(global->MainVerticalBox);
}


void interface_create_getgamespage()  {

//global->MainBox
	//global->MainVerticalBox
		GtkWidget *GameFrame;
			GtkWidget *GameScrollwin;
				//GameList
		GtkWidget *ButtonAndEntryHorizontalBox;
			GtkWidget *MetaServerFrame;
				GtkWidget *MetaServerHorizontalBox;
					GtkWidget *RefreshGameButton;
					GtkWidget *ShowServerButton;
			GtkWidget *AnotherServerFrame;
				GtkWidget *AnotherServerHorizontalBox;
					GtkWidget *HostLabel;
					GtkWidget *HostEntry;
					GtkWidget *PortLabel;
					GtkWidget *PortEntry;
					GtkWidget *GetgameButton;
			GtkWidget *ConnectButton;
		GtkWidget *MessageFrame;
			//global->MessageBox;
				//global->Message
				GtkWidget* MessageVerticalScrollbar;

	GtkWidget **AnotherServerData;
	gchar *text;
	guint16 connectid;

	global->phase = PHASE_GETGAMES;

	AnotherServerData = g_malloc(2 * sizeof(GtkWidget *) );

	gtk_widget_destroy(global->MainVerticalBox);
	global->MainVerticalBox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(global->MainBox), global->MainVerticalBox, TRUE, TRUE, 0);

	/* list of open game & gametype */
	GameFrame = gtk_frame_new("Start or Select a monopd game");
	gtk_container_set_border_width(GTK_CONTAINER(GameFrame), 15);
	gtk_box_pack_start(GTK_BOX(global->MainVerticalBox), GameFrame, TRUE, TRUE, 0);

	GameScrollwin = gtk_scrolled_window_new(NULL, NULL);
	gtk_container_set_border_width(GTK_CONTAINER(GameScrollwin), 10);
	gtk_container_add(GTK_CONTAINER(GameFrame), GameScrollwin);

	global->GameCList = gtk_clist_new(8);
	gtk_clist_set_reorderable(GTK_CLIST(global->GameCList), TRUE);
	gtk_clist_set_selection_mode(GTK_CLIST(global->GameCList), GTK_SELECTION_SINGLE);
	gtk_container_add(GTK_CONTAINER(GameScrollwin), global->GameCList);
	gtk_clist_column_titles_show(GTK_CLIST(global->GameCList) );
	gtk_clist_set_column_visibility(GTK_CLIST(global->GameCList), 5, FALSE);
	gtk_clist_set_column_visibility(GTK_CLIST(global->GameCList), 6, FALSE);
	gtk_clist_set_column_visibility(GTK_CLIST(global->GameCList), 7, FALSE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(global->GameCList), 0, TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(global->GameCList), 1, TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(global->GameCList), 2, TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(global->GameCList), 3, TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(global->GameCList), 4, TRUE);
	global->mode_gameclist = 0;
	gameclist_title_showgames();

	gtk_signal_connect(GTK_OBJECT(global->GameCList), "unselect_row", (GtkSignalFunc)Callback_GetGame_Unselect, NULL);
	gtk_signal_connect_after(GTK_OBJECT(global->GameCList), "select_row", (GtkSignalFunc)Callback_GetGame_Select, NULL);


	/* horizontal box for button / entry */
	ButtonAndEntryHorizontalBox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(global->MainVerticalBox), ButtonAndEntryHorizontalBox, FALSE, FALSE, 0);

	/* meta server frame */
	MetaServerFrame = gtk_frame_new("Meta server");
	gtk_box_pack_start(GTK_BOX(ButtonAndEntryHorizontalBox), MetaServerFrame, FALSE, FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(MetaServerFrame), BORDER);

	/* meta server horizontal box */
	MetaServerHorizontalBox = gtk_hbox_new(FALSE, BORDER);
	gtk_container_set_border_width(GTK_CONTAINER(MetaServerHorizontalBox), BORDER);
	gtk_container_add(GTK_CONTAINER(MetaServerFrame), MetaServerHorizontalBox);

	/* refresh button */
	ShowServerButton = gtk_button_new_with_label("Show servers");
//	gtk_widget_set_usize(ShowServerButton, 120, 0);
	gtk_box_pack_start(GTK_BOX(MetaServerHorizontalBox), ShowServerButton, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(ShowServerButton), "clicked", (GtkSignalFunc)Callback_ShowMetaServer, NULL);

	/* refresh button */
	RefreshGameButton = gtk_button_new_with_label("Refresh games");
//	gtk_widget_set_usize(RefreshGameButton, 120, 0);
	gtk_box_pack_start(GTK_BOX(MetaServerHorizontalBox), RefreshGameButton, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(RefreshGameButton), "clicked", (GtkSignalFunc)Callback_RefreshGameMetaServer, NULL);

	/* another server frame */
	AnotherServerFrame = gtk_frame_new("Another server");
	gtk_box_pack_start(GTK_BOX(ButtonAndEntryHorizontalBox), AnotherServerFrame, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(AnotherServerFrame), BORDER);

	/* Another server horizontal box */
	AnotherServerHorizontalBox = gtk_hbox_new(FALSE, BORDER);
	gtk_container_set_border_width(GTK_CONTAINER(AnotherServerHorizontalBox), BORDER);
	gtk_container_add(GTK_CONTAINER(AnotherServerFrame), AnotherServerHorizontalBox);

	/* label/entry host, label/entry port, get games button */
	HostLabel = gtk_label_new("Host :");
	gtk_box_pack_start(GTK_BOX(AnotherServerHorizontalBox), HostLabel, FALSE, FALSE, 0);

	HostEntry = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(AnotherServerHorizontalBox), HostEntry, TRUE, TRUE, 0);
	gtk_entry_set_text(GTK_ENTRY(HostEntry), config->getgames_host);
	AnotherServerData[0] = HostEntry;

	PortLabel = gtk_label_new("Port :");
	gtk_box_pack_start(GTK_BOX(AnotherServerHorizontalBox), PortLabel, FALSE, FALSE, 0);

	PortEntry = gtk_entry_new();
	gtk_widget_set_usize(PortEntry, 45, 0);
	gtk_box_pack_start(GTK_BOX(AnotherServerHorizontalBox), PortEntry, FALSE, FALSE, 0);
	text = g_strdup_printf("%d", config->getgames_port);
	gtk_entry_set_text(GTK_ENTRY(PortEntry), text);
	g_free(text);
	AnotherServerData[1] = PortEntry;

	GetgameButton = gtk_button_new_with_label("Get games");
//	gtk_widget_set_usize(GetgameButton, 100, 0);
	gtk_box_pack_start(GTK_BOX(AnotherServerHorizontalBox), GetgameButton, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(GetgameButton), "clicked", (GtkSignalFunc)Callback_GetgamesButton, (gpointer)AnotherServerData);

	/* big connect button */
	ConnectButton = gtk_button_new_with_label("CREATE/JOIN GAME");
	gtk_widget_set_usize(ConnectButton, 150, 0);
	gtk_container_set_border_width(GTK_CONTAINER(ConnectButton), BORDER);
	gtk_box_pack_start(GTK_BOX(ButtonAndEntryHorizontalBox), ConnectButton, FALSE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(ConnectButton), "clicked", (GtkSignalFunc)Callback_ConnectButton, NULL);

	/* message text */
	MessageFrame = gtk_frame_new("Messages");
	gtk_container_set_border_width(GTK_CONTAINER(MessageFrame), BORDER);
	gtk_widget_set_usize(MessageFrame, 0, 125);
	gtk_box_pack_start(GTK_BOX(global->MainVerticalBox), MessageFrame, FALSE, FALSE, 0);

	global->MessageBox = gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(MessageFrame), global->MessageBox);

	global->Message = gtk_text_new(NULL, NULL);
	global->message_nb_lines = 0;
	gtk_text_set_editable(GTK_TEXT(global->Message), FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(global->Message), TRUE);
	gtk_box_pack_start(GTK_BOX(global->MessageBox), global->Message, TRUE, TRUE, 0);
	MessageVerticalScrollbar = gtk_vscrollbar_new( GTK_TEXT(global->Message)->vadj );
	gtk_box_pack_start(GTK_BOX(global->MessageBox), MessageVerticalScrollbar, FALSE, FALSE, 0);

	gtk_widget_show_all(global->MainVerticalBox);

	/* autoconnect to server (getgamelist / getserverlist) */
	if(config->metaserver_autogetlist)  {

		Callback_ShowMetaServer(NULL);
		return;
	}

	if(config->metaserver_autogetgames)  {

		Callback_RefreshGameMetaServer(NULL);
	}

	if(config->getgames_autogetgames)  {

		if(! server_connect(&connectid, config->getgames_host, config->getgames_port) ) return;
		connection[connectid]->type = CONNECT_TYPE_MONOPD_GETGAME;
	}
}


void interface_create_gameconfigpage()  {

//global->MainBox
	//global->MainVerticalBox
		GtkWidget *HorizontalBox;
			GtkWidget *VerticalBoxLeft;
				GtkWidget *MessageFrame;
					//global->MessageBox;
				GtkWidget *ChatFrame;
					//game->ChatBox
						GtkWidget *ChatFrameHorizontalBox;
							//game->Chat
							GtkWidget* ChatVerticalScrollbar;
						GtkWidget *SendEntry;
			GtkWidget *VerticalBoxRight;
				GtkWidget *AlignementListFrame;
					GtkWidget *PlayerListFrame;
				GtkWidget *ConfigurationFrame;
				GtkWidget *HorizontalBoxButton;
					GtkWidget *StartButton;
					GtkWidget *LeaveButton;


	GtkWidget **SendData;
	gchar *titles[2];

	global->phase = PHASE_GAMECREATE;

	SendData = g_malloc(1 * sizeof(GtkWidget *) );

	gtk_widget_hide( GTK_WIDGET(global->MessageBox) );
	gtk_widget_reparent(GTK_WIDGET(global->MessageBox), global->Trick);
	gtk_widget_destroy(global->MainVerticalBox);
	global->MainVerticalBox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(global->MainBox), global->MainVerticalBox, TRUE, TRUE, 0);

	/* main horizontal box */
	HorizontalBox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(global->MainVerticalBox), HorizontalBox, TRUE, TRUE, 0);

	/* vertical box for messages */
	VerticalBoxLeft = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(HorizontalBox), VerticalBoxLeft, FALSE, FALSE, 0);

	/* message frame */
	MessageFrame = gtk_frame_new("Server Messages");
	gtk_container_set_border_width(GTK_CONTAINER(MessageFrame), 10);
	gtk_widget_set_usize(MessageFrame , 320, 0);
	gtk_box_pack_start(GTK_BOX(VerticalBoxLeft), MessageFrame, TRUE, TRUE, 0);

	gtk_text_set_point(GTK_TEXT(global->Message), 0);
	gtk_text_forward_delete(GTK_TEXT(global->Message), gtk_text_get_length(GTK_TEXT(global->Message)) );
	global->message_nb_lines = 0;
	gtk_widget_hide( GTK_WIDGET(global->MessageBox) );
	gtk_widget_reparent(GTK_WIDGET(global->MessageBox), MessageFrame);


	/* chat frame */
	ChatFrame = gtk_frame_new("Chat");
	gtk_container_set_border_width(GTK_CONTAINER(ChatFrame), 10);
	gtk_widget_set_usize(ChatFrame , 320, 350);
	gtk_box_pack_start(GTK_BOX(VerticalBoxLeft), ChatFrame, FALSE, FALSE, 0);

	game->ChatBox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(ChatFrame), game->ChatBox);

	ChatFrameHorizontalBox = gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(game->ChatBox), ChatFrameHorizontalBox);

	game->Chat = gtk_text_new(NULL, NULL);
	game->chat_nb_lines = 0;
	gtk_text_set_editable(GTK_TEXT(game->Chat), FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(game->Chat), TRUE);
	gtk_box_pack_start(GTK_BOX(ChatFrameHorizontalBox), game->Chat, TRUE, TRUE, 0);

	ChatVerticalScrollbar = gtk_vscrollbar_new( GTK_TEXT(game->Chat)->vadj );
	gtk_box_pack_start(GTK_BOX(ChatFrameHorizontalBox), ChatVerticalScrollbar, FALSE, FALSE, 0);

	/* send entry */
	SendEntry = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(game->ChatBox), SendEntry, FALSE, FALSE, 0);

	SendData[0] = SendEntry;
	gtk_signal_connect(GTK_OBJECT(SendEntry), "activate", (GtkSignalFunc)Callback_SendButton, (gpointer)SendData);


	/* vertical box right */
	VerticalBoxRight = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(HorizontalBox), VerticalBoxRight, TRUE, TRUE, 0);

	/* player list frame */
	PlayerListFrame = gtk_frame_new("Players");
	gtk_container_set_border_width(GTK_CONTAINER(PlayerListFrame), 10);
	gtk_box_pack_start(GTK_BOX(VerticalBoxRight), PlayerListFrame, TRUE, TRUE, 0);

	AlignementListFrame = gtk_alignment_new(0.0, 0.0, 1.0, 1.0);
	gtk_container_set_border_width(GTK_CONTAINER(AlignementListFrame), 10);
	gtk_container_add(GTK_CONTAINER(PlayerListFrame), AlignementListFrame);

	titles[0] = g_strdup("Name");
	titles[1] = g_strdup("Host");
	game->PlayerCList = gtk_clist_new_with_titles(2, titles);
	g_free(titles[0]);
	g_free(titles[1]);
	gtk_clist_set_column_auto_resize(GTK_CLIST(game->PlayerCList), 0, TRUE);
	gtk_clist_column_titles_passive(GTK_CLIST(game->PlayerCList));
	gtk_clist_set_reorderable(GTK_CLIST(game->PlayerCList), FALSE);
	gtk_clist_set_selection_mode(GTK_CLIST(game->PlayerCList), GTK_SELECTION_SINGLE);
	gtk_container_add(GTK_CONTAINER(AlignementListFrame), game->PlayerCList);

	/* game configuration frame */
	ConfigurationFrame = gtk_frame_new("Game Configuration");
	gtk_container_set_border_width(GTK_CONTAINER(ConfigurationFrame), 10);
	gtk_widget_set_usize(ConfigurationFrame , 0, 150);
	gtk_box_pack_start(GTK_BOX(VerticalBoxRight), ConfigurationFrame, FALSE, FALSE, 0);

	/* horizontal box button */
	HorizontalBoxButton = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(HorizontalBoxButton), 30);
	gtk_box_set_spacing(GTK_BOX(HorizontalBoxButton), 30);
	gtk_box_pack_start(GTK_BOX(VerticalBoxRight), HorizontalBoxButton, FALSE, TRUE, 0);

	/* leave button */
	LeaveButton = gtk_button_new_with_label("LEAVE GAME");
	gtk_widget_set_usize(LeaveButton, 0, 30);
	gtk_box_pack_start(GTK_BOX(HorizontalBoxButton), LeaveButton, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(LeaveButton), "clicked", (GtkSignalFunc)Callback_LeaveButton, NULL);

	/* start button */
	if(game->type == GAME_TYPE_CREATE)  {

		StartButton = gtk_button_new_with_label("START GAME");
		gtk_widget_set_usize(StartButton, 0, 30);
		gtk_box_pack_start(GTK_BOX(HorizontalBoxButton), StartButton, TRUE, TRUE, 0);
		gtk_signal_connect(GTK_OBJECT(StartButton), "clicked", (GtkSignalFunc)Callback_StartButton, NULL);
	}

	gtk_widget_show_all(global->MainVerticalBox);
}


void interface_create_gameinitpage()  {

//global->MainBox
	//global->MainVerticalBox
		GtkWidget *Alignment;
			GtkWidget *Label;

	global->phase = PHASE_GAMEINIT;

	gtk_widget_hide( GTK_WIDGET(global->MessageBox) );
	gtk_widget_reparent(GTK_WIDGET(global->MessageBox), global->Trick);
	gtk_widget_hide( GTK_WIDGET(game->ChatBox) );
	gtk_widget_reparent(GTK_WIDGET(game->ChatBox), global->Trick);
	gtk_widget_destroy(global->MainVerticalBox);
	global->MainVerticalBox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(global->MainBox), global->MainVerticalBox, TRUE, TRUE, 0);	

	/* text */
	Alignment = gtk_alignment_new(0.5, 0.5, 0.0, 0.0);
	gtk_box_pack_start(GTK_BOX(global->MainVerticalBox), Alignment, TRUE, TRUE, 0);

	Label = gtk_label_new("Please wait while loading...");
	gtk_container_add(GTK_CONTAINER(Alignment), Label);


	gtk_widget_show_all(global->MainVerticalBox);
	while(gtk_events_pending()) gtk_main_iteration();
}


void interface_create_gameboardpage()  {

//global->MainBox
	//global->MainVerticalBox
		GtkWidget *MainHorizontalBox;
			GtkWidget *VerticalBoxPlayerlistMessageChat;
				GtkWidget *PlayerVerticalBox;
					GtkWidget *PlayerHorizontalBox;
						GtkWidget *AlignementTokenPlayer;
							//game->player[].playerlist_token_gdkrgb
						GtkWidget *PlayerTable;
							//game->player[i].playerlist_AlignementNamePlayer;
								//game->player[].playerlist_LabelNamePlayer
							//game->player[i].playerlist_AlignementMoneyPlayer;
								//game->player[].playerlist_LabelMoneyPlayer
							//game->player[].playerlist_cards_gdkrgb
					GtkWidget *PlayerSeparator;
				//game->BoxMessageAndChat
					//call interface_message_and_chat_float_unfloat
			GtkWidget *VerticalBoxBoard;
				GtkWidget *BoardTable;
					//game->BoardCenter;
					//game->estate[].gdkrgb

	GtkWidget **SendData;
	guint32 frame, pic, pic2;
	guint32 i, j, t, token;
	gchar *text;

	GtkStyle *style;
	GdkColor gdk_color;
	guint32  bg_color;


	global->phase = PHASE_GAMEPLAY;

	SendData = g_malloc(1 * sizeof(GtkWidget *) );

	gtk_widget_hide( GTK_WIDGET(global->MessageBox) );
	gtk_widget_reparent(GTK_WIDGET(global->MessageBox), global->Trick);
	gtk_widget_hide( GTK_WIDGET(game->ChatBox) );
	gtk_widget_reparent(GTK_WIDGET(game->ChatBox), global->Trick);
	gtk_widget_destroy(global->MainVerticalBox);
	global->MainVerticalBox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(global->MainBox), global->MainVerticalBox, TRUE, TRUE, 0);

	/* horizontal box for board / player status */
	MainHorizontalBox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(global->MainVerticalBox), MainHorizontalBox, TRUE, TRUE, 0);

	/* vertical box for player / messages / chat */
	VerticalBoxPlayerlistMessageChat = gtk_vbox_new(FALSE, 0);
	if(config->game_playerlist_position == GAME_PLAYERLIST_POS_RIGHT)
		gtk_box_pack_end(GTK_BOX(MainHorizontalBox), VerticalBoxPlayerlistMessageChat, TRUE, TRUE, 0);
	else /* left (default) */
		gtk_box_pack_start(GTK_BOX(MainHorizontalBox), VerticalBoxPlayerlistMessageChat, TRUE, TRUE, 0);

	/* player status */
	PlayerVerticalBox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(PlayerVerticalBox), BORDER);
	gtk_box_pack_start(GTK_BOX(VerticalBoxPlayerlistMessageChat), PlayerVerticalBox, FALSE, FALSE, 0);

	/* set buffer_token & buffer_stair */
	for(i = 0, j = 0 ; i < MAX_PLAYERS ; i++)  {

		if(! game->player[i].playerid) continue;

		game->player[i].buffer_token = j;
		game->player[i].buffer_stair = j;
		j++;
	}

	/* get background color */
	style = gtk_widget_get_style(PlayerVerticalBox);
	gdk_color = style->bg[0];
	bg_color = (gdk_color.red >> 8) << 16 | (gdk_color.green >> 8) << 8 | (gdk_color.blue >> 8);

	/* player list game */
	for(i = 0 ; i < MAX_PLAYERS ; i++)  {

		if(! game->player[i].playerid) continue;

		token = game->player[i].buffer_token;

		/* separator */
		PlayerSeparator = gtk_hseparator_new();
		gtk_box_pack_start(GTK_BOX(PlayerVerticalBox), PlayerSeparator, FALSE, FALSE, 0);

		/* box which contain all widgets for a player */
		PlayerHorizontalBox = gtk_hbox_new(FALSE, 0);
		gtk_style_copy(PlayerHorizontalBox->style);
		gtk_widget_set_style(PlayerHorizontalBox,  global->style_normal);
		gtk_box_pack_start(GTK_BOX(PlayerVerticalBox), PlayerHorizontalBox, FALSE, FALSE, 0);

		/* token player in playerlist */
		AlignementTokenPlayer = gtk_alignment_new(1.0, 1.0, 0.0, 0.0);
		gtk_box_pack_start(GTK_BOX(PlayerHorizontalBox), AlignementTokenPlayer, TRUE, TRUE, 0);
		game->player[i].playerlist_token_gdkrgb = gtk_drawing_area_new();
		gtk_drawing_area_size( GTK_DRAWING_AREA (game->player[i].playerlist_token_gdkrgb), data->playerlist_token_width,  data->playerlist_token_height );
		gtk_container_add(GTK_CONTAINER(AlignementTokenPlayer), game->player[i].playerlist_token_gdkrgb);
		gtk_signal_connect (GTK_OBJECT (game->player[i].playerlist_token_gdkrgb), "expose_event", GTK_SIGNAL_FUNC (on_playertoken_expose), NULL);

		text = g_strdup_printf("%d", i);
		gtk_object_set_data_full(GTK_OBJECT(game->player[i].playerlist_token_gdkrgb), "player", text, g_free);

		/* name, money, cards owned by player */
		PlayerTable = gtk_table_new(2, 2, FALSE);
		gtk_table_set_row_spacings(GTK_TABLE(PlayerTable), 0);
		gtk_table_set_col_spacings(GTK_TABLE(PlayerTable), 0);
		gtk_box_pack_start(GTK_BOX(PlayerHorizontalBox), PlayerTable, FALSE, FALSE, 0);

		/* cards */
		game->player[i].playerlist_cards_gdkrgb = gtk_drawing_area_new();
		gtk_table_attach_defaults(GTK_TABLE(PlayerTable),  game->player[i].playerlist_cards_gdkrgb,  0,  2,  1,  2);
		gtk_drawing_area_size( GTK_DRAWING_AREA (game->player[i].playerlist_cards_gdkrgb), data->playerlist_cards_width,  data->playerlist_cards_height );
		gtk_signal_connect (GTK_OBJECT (game->player[i].playerlist_cards_gdkrgb), "expose_event", GTK_SIGNAL_FUNC (on_playercards_expose), NULL);

		text = g_strdup_printf("%d", i);
		gtk_object_set_data_full(GTK_OBJECT(game->player[i].playerlist_cards_gdkrgb), "player", text, g_free);

		/* name */
		game->player[i].playerlist_AlignementNamePlayer = gtk_alignment_new(0.0, 0.0, 0.0, 0.0);
		gtk_table_attach_defaults(GTK_TABLE(PlayerTable),  game->player[i].playerlist_AlignementNamePlayer,  0,  1,  0,  1);
		game->player[i].playerlist_LabelNamePlayer = gtk_label_new(game->player[i].name);
		gtk_object_set_data_full(GTK_OBJECT(game->player[i].playerlist_AlignementNamePlayer), "namelabel", game->player[i].playerlist_LabelNamePlayer, g_free);
		gtk_container_add(GTK_CONTAINER(game->player[i].playerlist_AlignementNamePlayer), game->player[i].playerlist_LabelNamePlayer);

		/* money */
		game->player[i].playerlist_AlignementMoneyPlayer = gtk_alignment_new(1.0, 0.0, 0.0, 0.0);
		gtk_table_attach_defaults(GTK_TABLE(PlayerTable),  game->player[i].playerlist_AlignementMoneyPlayer,  1,  2,  0,  1);
		text = g_strdup_printf("%d", game->player[i].money);
		game->player[i].playerlist_LabelMoneyPlayer = gtk_label_new(text);
		g_free(text);
		gtk_object_set_data_full(GTK_OBJECT(game->player[i].playerlist_AlignementMoneyPlayer), "moneylabel", game->player[i].playerlist_LabelMoneyPlayer, g_free);
		gtk_container_add(GTK_CONTAINER(game->player[i].playerlist_AlignementMoneyPlayer), game->player[i].playerlist_LabelMoneyPlayer);

		/* playerlist token frame */
		frame = game->player[i].playerlist_token_frame = frame_create();
		frame_set_width(frame, data->playerlist_token_width);
		frame_set_height(frame, data->playerlist_token_height);
		if(data->playerlist_token_bgcolor < 0)
			frame_set_bgcolor(frame, bg_color);
		else
			frame_set_bgcolor(frame, data->playerlist_token_bgcolor);

		/* playerlist token alpha */
		pic = game->player[i].playerlist_token_alpha = pic_create(frame);
		pic_is_alphamask(frame, pic);
		pic_set_width(frame, pic, data->pngfile_token_width[token]);
		pic_set_height(frame, pic, data->pngfile_token_height[token]);
		pic_buff(frame, pic, data->pngfile_token_alpha[token]);

		/* playerlist token pic */
		pic = game->player[i].playerlist_token_pic = pic_create(frame);
		pic_set_x(frame, pic, (data->playerlist_token_width - data->pngfile_token_width[token]) / 2);
		pic_set_y(frame, pic, (data->playerlist_token_height - data->pngfile_token_height[token]) / 2);
		pic_set_z(frame, pic, 0);
		pic_set_width(frame, pic, data->pngfile_token_width[token]);
		pic_set_height(frame, pic, data->pngfile_token_height[token]);
		pic_set_alphamask(frame, pic, game->player[i].playerlist_token_alpha);
		pic_buff(frame, pic, data->pngfile_token_image[token]);

		/* engine frame cards */
		frame = game->player[i].playerlist_cards_frame = frame_create();
		frame_set_width(frame, data->playerlist_cards_width);
		frame_set_height(frame, data->playerlist_cards_height);
		if(data->playerlist_cards_bgcolor < 0)
			frame_set_bgcolor(frame, bg_color);
		else
			frame_set_bgcolor(frame, data->playerlist_cards_bgcolor);

		/* cards */
		for(j = 0 ; j < data->number_playerlist_card ; j++)  {

			pic = game->player[i].playerlist_cards_pic[j] = pic_create(frame);
			pic_set_x(frame, pic, data->playerlist_card[j].x);
			pic_set_y(frame, pic, data->playerlist_card[j].y);
			pic_set_z(frame, pic, data->playerlist_card[j].z);
			t = data->playerlist_card[j].buffer_card;
			pic_set_width(frame, pic, data->pngfile_card_width[t]);
			pic_set_height(frame, pic, data->pngfile_card_height[t]);
			pic_set_alpha(frame, pic, data->playerlist_cards_alphaunowned);
			pic_set_bgcolor(frame, pic, data->playerlist_cards_cardbgcolor);
			pic_buff(frame, pic, data->pngfile_card_image[t]);
		}
	}

	/* last separator */
	PlayerSeparator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(PlayerVerticalBox), PlayerSeparator, FALSE, FALSE, 0);

	/* message and chat box */
	game->BoxMessageAndChat = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(VerticalBoxPlayerlistMessageChat), game->BoxMessageAndChat, TRUE, TRUE, 0);

	if(game->nb_players <= 5)  {

		game->message_float = 0;
		game->chat_float = 0;
	}
	else if(game->nb_players <= 7)  {

		game->message_float = 0;
		game->chat_float = 1;
	}
	else  {

		game->message_float = 1;
		game->chat_float = 1;
	}
	interface_message_and_chat_float_unfloat();


	/* vertical box for board / left space */
	VerticalBoxBoard = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(MainHorizontalBox), VerticalBoxBoard, FALSE, FALSE, 0);

	/* board */
	BoardTable = gtk_table_new(11, 11, FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(BoardTable), BORDER);
	gtk_table_set_row_spacings(GTK_TABLE(BoardTable), 0);
	gtk_table_set_col_spacings(GTK_TABLE(BoardTable), 0);
	gtk_box_pack_start(GTK_BOX(VerticalBoxBoard), BoardTable, FALSE, FALSE, 0);

	/* board center */
	game->BoardCenter = gtk_vbox_new(FALSE, 0);
	gtk_table_attach_defaults(GTK_TABLE(BoardTable), game->BoardCenter, 1,10, 1,10);
	interface_create_message_boardcenter();

	for(i = 0 ; i < data->number_estates ; i++)  {

		j = data->estate[i].buffer_board;

		game->estate[i].gdkrgb = gtk_drawing_area_new();
		gtk_drawing_area_size( GTK_DRAWING_AREA (game->estate[i].gdkrgb), data->pngfile_board_width[j],  data->pngfile_board_height[j] );
		gtk_widget_set_events(GTK_WIDGET(game->estate[i].gdkrgb), GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK);

		gtk_table_attach_defaults(GTK_TABLE(BoardTable),  game->estate[i].gdkrgb,  data->estate[i].xtable,  data->estate[i].xtable +1,  data->estate[i].ytable,  data->estate[i].ytable +1 );

		text = g_strdup_printf("%d", i);
		gtk_object_set_data_full(GTK_OBJECT(game->estate[i].gdkrgb), "estateid", text, g_free);

		gtk_signal_connect_after (GTK_OBJECT (game->estate[i].gdkrgb), "enter_notify_event", GTK_SIGNAL_FUNC (Callback_EnterAnEstate), NULL);
		gtk_signal_connect (GTK_OBJECT (game->estate[i].gdkrgb), "leave_notify_event", GTK_SIGNAL_FUNC (Callback_LeaveAnEstate), NULL);
		gtk_signal_connect (GTK_OBJECT (game->estate[i].gdkrgb), "button_press_event", GTK_SIGNAL_FUNC (Callback_ClicOnEstate), NULL);
		gtk_signal_connect (GTK_OBJECT (game->estate[i].gdkrgb), "expose_event", GTK_SIGNAL_FUNC (on_board_expose), NULL);
	}

	/* command box */
	game->CommandsBox = gtk_hbox_new(FALSE, BORDER);
	gtk_container_set_border_width(GTK_CONTAINER(game->CommandsBox), BORDER);
	gtk_box_pack_start(GTK_BOX(VerticalBoxBoard), game->CommandsBox, TRUE, TRUE, 0);

	gtk_timeout_add(50, interface_update_command_button, NULL);


	/* board frame */
	frame = game->board_frame = frame_create();
	frame_set_width(frame, data->board_width);
	frame_set_height(frame, data->board_height);

	/* pic for estates / stairs / houses */
	for(i = 0 ; i < data->number_estates ; i++)  {

		j = data->estate[i].buffer_board;

		/* estate */
		pic = game->estate[i].pic = pic_create(frame);
		pic_set_x(frame, pic, data->estate[i].x);
		pic_set_y(frame, pic, data->estate[i].y);
		pic_set_z(frame, pic, 0);
		pic_set_width(frame, pic, data->pngfile_board_width[j]);
		pic_set_height(frame, pic, data->pngfile_board_height[j]);
		pic_buff(frame, pic, data->pngfile_board_image[j]);


		/* stair alpha */
		pic = game->estate[i].stair_alpha = pic_create(frame);
		pic_is_alphamask(frame, pic);

		/* stair */
		pic = game->estate[i].stair_pic = pic_create(frame);
		pic_set_x(frame, pic, data->estate[i].xstair);
		pic_set_y(frame, pic, data->estate[i].ystair);
		pic_set_z(frame, pic, 1);
		pic_set_alphamask(frame, pic, game->estate[i].stair_alpha);
		pic_unshow(frame, pic);


		/* house alpha */
		pic = game->estate[i].house_alpha = pic_create(frame);
		pic_is_alphamask(frame, pic);

		/* house image */
		pic = game->estate[i].house_pic = pic_create(frame);
		pic_set_x(frame, pic, data->estate[i].xhouse);
		pic_set_y(frame, pic, data->estate[i].yhouse);
		pic_set_z(frame, pic, 1);
		pic_set_alphamask(frame, pic, game->estate[i].house_alpha);
		pic_unshow(frame, pic);
	}

	/* pic for tokens */
	for(i = 0 ; i < MAX_PLAYERS ; i++)  {

		if(! game->player[i].playerid) continue;

		token = game->player[i].buffer_token;

		/* token alpha */
		pic = game->player[i].token_alpha = pic_create(frame);
		pic_is_alphamask(frame, pic);
		pic_set_width(frame, pic, data->pngfile_token_width[token]);
		pic_set_height(frame, pic, data->pngfile_token_height[token]);
		pic_buff(frame, pic, data->pngfile_token_alpha[token]);

		/* token */
		pic = game->player[i].token_pic = pic_create(frame);
		pic_set_x(frame, pic, data->estate[ game->player[i].location ].xtoken);
		pic_set_y(frame, pic, data->estate[ game->player[i].location ].ytoken);
		pic_set_z(frame, pic, 1);
		pic_set_width(frame, pic, data->pngfile_token_width[token]);
		pic_set_height(frame, pic, data->pngfile_token_height[token]);
		pic_set_alphamask(frame, pic, game->player[i].token_alpha);
		pic_buff(frame, pic, data->pngfile_token_image[token]);
	}

	gtk_widget_show_all(global->MainVerticalBox);
}


/* create message box, chat box fixed or floating */
void interface_message_and_chat_float_unfloat()  {

	//game->BoxMessageAndChat
		//global->MessageFrame
		//global->MessageWindow
			//global->MessageBox
		//global->ChatFrame
		//global->ChatWindow
			//game->ChatBox

	/* message is fixed and not created */
	if(!game->message_float  &&  !global->MessageFrame) {

		/* if message window is created */
		if(global->MessageWindow)  {

			gtk_widget_hide( GTK_WIDGET(global->MessageBox) );
			gtk_widget_reparent(GTK_WIDGET(global->MessageBox), global->Trick);
			gtk_widget_destroy(global->MessageWindow);
			global->MessageWindow = 0;
		}
		global->MessageFrame = gtk_frame_new("Server Messages");
		gtk_container_set_border_width(GTK_CONTAINER(global->MessageFrame), BORDER);
		gtk_box_pack_start(GTK_BOX(game->BoxMessageAndChat), global->MessageFrame, TRUE, TRUE, 0);			

		gtk_widget_hide( GTK_WIDGET(global->MessageBox) );
		gtk_widget_reparent(GTK_WIDGET(global->MessageBox), global->MessageFrame);
		gtk_widget_show_all(global->MessageFrame);
	}

	/* message is float and not created */
	if(game->message_float  &&  !global->MessageWindow)  {

		/* if message fixed is created */
		if(global->MessageFrame)  {

			gtk_widget_hide( GTK_WIDGET(global->MessageBox) );
			gtk_widget_reparent(GTK_WIDGET(global->MessageBox), global->Trick);
			gtk_widget_destroy(global->MessageFrame);
			global->MessageFrame = 0;
			while(gtk_events_pending()) gtk_main_iteration();
		}
		global->MessageWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(global->MessageWindow), "Server Messages");
		gtk_window_set_policy(GTK_WINDOW(global->MessageWindow), TRUE, TRUE, FALSE);
		gtk_widget_set_usize(global->MessageWindow, 300, 230);
		gtk_signal_connect(GTK_OBJECT(global->MessageWindow), "delete_event", (GtkSignalFunc)CallBack_delete_window_message, NULL);
		gtk_signal_connect(GTK_OBJECT(global->MessageWindow), "destroy", (GtkSignalFunc)CallBack_destroy_window_message, NULL);

		gtk_widget_hide( GTK_WIDGET(global->MessageBox) );
		gtk_widget_reparent(GTK_WIDGET(global->MessageBox), global->MessageWindow);
		gtk_widget_show_all(global->MessageWindow);
	}


	/* chat is fixed and not created */
	if(!game->chat_float  &&  !game->ChatFrame) {

		/* if chat window is created */
		if(game->ChatWindow)  {

			gtk_widget_hide( GTK_WIDGET(game->ChatBox) );
			gtk_widget_reparent(GTK_WIDGET(game->ChatBox), global->Trick);
			gtk_widget_destroy(game->ChatWindow);
			game->ChatWindow = 0;
		}
		game->ChatFrame = gtk_frame_new("Chat");
		gtk_container_set_border_width(GTK_CONTAINER(game->ChatFrame), BORDER);
		gtk_box_pack_end(GTK_BOX(game->BoxMessageAndChat), game->ChatFrame, TRUE, TRUE, 0);			

		gtk_widget_hide( GTK_WIDGET(game->ChatBox) );
		gtk_widget_reparent(GTK_WIDGET(game->ChatBox), game->ChatFrame);
		gtk_widget_show_all(game->ChatFrame);
	}

	/* chat is float and not created */
	if(game->chat_float  &&  !game->ChatWindow)  {

		/* if chat fixed is created */
		if(game->ChatFrame)  {

			gtk_widget_hide( GTK_WIDGET(game->ChatBox) );
			gtk_widget_reparent(GTK_WIDGET(game->ChatBox), global->Trick);
			gtk_widget_destroy(game->ChatFrame);
			game->ChatFrame = 0;
			while(gtk_events_pending()) gtk_main_iteration();
		}
		game->ChatWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(game->ChatWindow), "Chat");
		gtk_window_set_policy(GTK_WINDOW(game->ChatWindow), TRUE, TRUE, FALSE);
		gtk_widget_set_usize(game->ChatWindow, 300, 230);
		gtk_signal_connect(GTK_OBJECT(game->ChatWindow), "delete_event", (GtkSignalFunc)CallBack_delete_window_chat, NULL);
		gtk_signal_connect(GTK_OBJECT(game->ChatWindow), "destroy", (GtkSignalFunc)CallBack_destroy_window_chat, NULL);

		gtk_widget_hide( GTK_WIDGET(game->ChatBox) );
		gtk_widget_reparent(GTK_WIDGET(game->ChatBox), game->ChatWindow);
		gtk_widget_show_all(game->ChatWindow);
	}
}


gboolean interface_update_command_button()  {

	gint8 me, slot;
	GtkWidget *Label;

	me = get_player_slot_with_playerid( connection[ game->connectid ]->playerid );

	/* create roll button */
	if(game->player[me].can_roll  &&  get_command_button_slot_with_command(".r\n") < 0 )  {

		game_get_valid_command_slot(&slot);

		game->command[slot].Frame = gtk_button_new_with_label("Roll");
		gtk_widget_set_usize(game->command[slot].Frame, 60, 0);
		gtk_object_set_data(GTK_OBJECT(game->command[slot].Frame), "command", ".r\n");
		gtk_box_pack_start(GTK_BOX(game->CommandsBox), game->command[slot].Frame, FALSE, FALSE, 0);
		gtk_signal_connect(GTK_OBJECT(game->command[slot].Frame), "clicked", (GtkSignalFunc)CallBack_button_command_pressed, NULL);
		game->command[slot].command = g_strdup(".r\n");
		game->command[slot].open = TRUE;
	}

	/* destroy roll button */
	if(!game->player[me].can_roll  &&  (slot = get_command_button_slot_with_command(".r\n")) >= 0  )  {

		gtk_widget_destroy( game->command[slot].Frame );
		game->command[slot].Frame = 0;
		game->command[slot].gdkrgb = 0;
		game->command[slot].redraw = 0;
		g_free( game->command[slot].command );
		game->command[slot].command = 0;
		game->command[slot].open = 0;
	}

	/* create buy estate button */
	if(game->player[me].can_buyestate  &&  get_command_button_slot_with_command(".eb\n") < 0 )  {

		game_get_valid_command_slot(&slot);

		game->command[slot].Frame = gtk_button_new_with_label("Buy Estate");
		gtk_widget_set_usize(game->command[slot].Frame, 100, 0);
		gtk_object_set_data(GTK_OBJECT(game->command[slot].Frame), "command", ".eb\n");
		gtk_box_pack_start(GTK_BOX(game->CommandsBox), game->command[slot].Frame, FALSE, FALSE, 0);
		gtk_signal_connect(GTK_OBJECT(game->command[slot].Frame), "clicked", (GtkSignalFunc)CallBack_button_command_pressed, NULL);
		game->command[slot].command = g_strdup(".eb\n");
		game->command[slot].open = TRUE;
	}

	/* destroy buy estate button */
	if(!game->player[me].can_buyestate  &&  (slot = get_command_button_slot_with_command(".eb\n")) >= 0  )  {

		gtk_widget_destroy( game->command[slot].Frame );
		game->command[slot].Frame = 0;
		game->command[slot].gdkrgb = 0;
		game->command[slot].redraw = 0;
		g_free( game->command[slot].command );
		game->command[slot].command = 0;
		game->command[slot].open = 0;
	}

	/* create auction estate button */
	if(game->player[me].can_buyestate  &&  get_command_button_slot_with_command(".ea\n") < 0 )  {

		game_get_valid_command_slot(&slot);

		game->command[slot].Frame = gtk_button_new_with_label("Auction Estate");
		gtk_widget_set_usize(game->command[slot].Frame, 120, 0);
		gtk_object_set_data(GTK_OBJECT(game->command[slot].Frame), "command", ".ea\n");
		gtk_box_pack_start(GTK_BOX(game->CommandsBox), game->command[slot].Frame, FALSE, FALSE, 0);
		gtk_signal_connect(GTK_OBJECT(game->command[slot].Frame), "clicked", (GtkSignalFunc)CallBack_button_command_pressed, NULL);
		game->command[slot].command = g_strdup(".ea\n");
		game->command[slot].open = TRUE;
	}

	/* destroy auction estate button */
	if(!game->player[me].can_buyestate  &&  (slot = get_command_button_slot_with_command(".ea\n")) >= 0  )  {

		gtk_widget_destroy( game->command[slot].Frame );
		game->command[slot].Frame = 0;
		game->command[slot].gdkrgb = 0;
		game->command[slot].redraw = 0;
		g_free( game->command[slot].command );
		game->command[slot].command = 0;
		game->command[slot].open = 0;
	}

	gtk_widget_show_all(game->CommandsBox);
	return TRUE;
}


void interface_create_message_boardcenter()  {

	GtkWidget *vbox;
		GtkWidget *Alignement;
			GtkWidget *Label;

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 15);
	gtk_object_set_data(GTK_OBJECT(game->BoardCenter), "boardcenter", vbox);
	gtk_box_pack_start(GTK_BOX(game->BoardCenter), vbox, TRUE, TRUE, 0);

	Alignement = gtk_alignment_new(0.5, 0.0, 0.0, 0.0);
	gtk_box_pack_start(GTK_BOX(vbox), Alignement, TRUE, TRUE, 0);

	Label = gtk_label_new("Press left button on estate for build houses.\nPress right button on estate for sell houses.\nPress middle button on estate for toggle mortgage.\n");
	gtk_container_add(GTK_CONTAINER(Alignement), Label);

	gtk_widget_show_all(vbox);
}


void interface_create_auctionbox()  {

	GtkWidget *vbox;
		GtkWidget *hbox_text;
			GtkWidget *text;
			GtkWidget *scrollbar;
		GtkWidget *hbox_entry;
			GtkWidget *entry;
			GtkWidget *button;

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 15);
	gtk_object_set_data(GTK_OBJECT(game->BoardCenter), "boardcenter", vbox);
	gtk_box_pack_start(GTK_BOX(game->BoardCenter), vbox, TRUE, TRUE, 0);

	hbox_text = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox_text, TRUE, TRUE, 0);

	hbox_entry = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox_entry, FALSE, TRUE, 0);

	/* text box */
	text = gtk_text_new(NULL, NULL);
	gtk_text_set_editable(GTK_TEXT(text), FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(text), TRUE);
	gtk_object_set_data(GTK_OBJECT(game->BoardCenter), "auction_text", text);
	gtk_box_pack_start(GTK_BOX(hbox_text), text, TRUE, TRUE, 0);

	scrollbar = gtk_vscrollbar_new( GTK_TEXT(text)->vadj );
	gtk_box_pack_start(GTK_BOX(hbox_text), scrollbar, FALSE, FALSE, 0);

	/* send entry */
	entry = gtk_entry_new();
	gtk_object_set_data(GTK_OBJECT(game->BoardCenter), "auction_entry", entry);
	gtk_box_pack_start(GTK_BOX(hbox_entry), entry,TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(entry), "activate", (GtkSignalFunc)Callback_AuctionButton, (gpointer)entry);

	button = gtk_button_new_with_label("Bid");
	gtk_widget_set_usize(button, 60, 0);

	gtk_box_pack_start(GTK_BOX(hbox_entry), button, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(button), "clicked", (GtkSignalFunc)Callback_AuctionButton, (gpointer)entry);

	gtk_widget_show_all(vbox);
}


void interface_flush_boardcenter()  {

	GtkWidget *widget;

	widget = gtk_object_get_data(GTK_OBJECT(game->BoardCenter), "boardcenter");
	if( GTK_IS_WIDGET(widget) )  gtk_widget_destroy(widget);
}


/* create about window */
void interface_create_aboutwin()  {

	GtkWidget *AboutWin;
		GtkWidget *Frame;
			GtkWidget *VBox;
				GtkWidget *Alignment;
					GtkWidget *Label;
					GtkWidget *Button;

	guchar *text;

	AboutWin = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(AboutWin), "About");
	gtk_window_set_policy(GTK_WINDOW(AboutWin), FALSE, FALSE, TRUE);
	gtk_window_set_position(GTK_WINDOW(AboutWin), GTK_WIN_POS_CENTER);
	gtk_window_set_transient_for(GTK_WINDOW(AboutWin), GTK_WINDOW(global->MainWin));
	gtk_window_set_modal(GTK_WINDOW(AboutWin), TRUE);
	gtk_widget_set_usize(AboutWin, 300, 0);
	gtk_signal_connect(GTK_OBJECT(AboutWin), "delete_event", (GtkSignalFunc)gtk_widget_destroy, NULL);

	Frame = gtk_frame_new(NULL);
	gtk_container_set_border_width(GTK_CONTAINER(Frame), 10);
	gtk_container_add(GTK_CONTAINER(AboutWin), Frame);

	VBox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(Frame), VBox);

	/* name  */
	Alignment = gtk_alignment_new(0.5, 1.0, 0.0, 0.0);
	gtk_widget_set_usize(Alignment, 0, 30);
	gtk_box_pack_start(GTK_BOX(VBox), Alignment, FALSE, TRUE, 0);
	Label = gtk_label_new("GtkAtlantic");
	gtk_container_add(GTK_CONTAINER(Alignment), Label);

	/* version */
	Alignment = gtk_alignment_new(0.5, 0.5, 0.0, 0.0);
	gtk_box_pack_start(GTK_BOX(VBox), Alignment, FALSE, TRUE, 0);
	text = g_strdup_printf("Version %s", VERSION);
	Label = gtk_label_new(text);
	g_free(text);
	gtk_container_add(GTK_CONTAINER(Alignment), Label);

	/* web site */
	Alignment = gtk_alignment_new(0.5, 0.0, 0.0, 0.0);
	gtk_widget_set_usize(Alignment, 0, 30);
	gtk_box_pack_start(GTK_BOX(VBox), Alignment, FALSE, TRUE, 0);
	Label = gtk_label_new("http://gtkatlantic.sourceforge.net");
	gtk_container_add(GTK_CONTAINER(Alignment), Label);

	/* license */
	Alignment = gtk_alignment_new(0.5, 0.5, 0.0, 0.0);
	gtk_box_pack_start(GTK_BOX(VBox), Alignment, FALSE, TRUE, 0);
	Label = gtk_label_new("This software is distributed under");
	gtk_container_add(GTK_CONTAINER(Alignment), Label);

	Alignment = gtk_alignment_new(0.5, 0.5, 0.0, 0.0);
	gtk_box_pack_start(GTK_BOX(VBox), Alignment, FALSE, TRUE, 0);
	Label = gtk_label_new("GPL Version 2 or any later version");
	gtk_container_add(GTK_CONTAINER(Alignment), Label);

	/* author */
	Alignment = gtk_alignment_new(0.5, 1.0, 0.0, 0.0);
	gtk_widget_set_usize(Alignment, 0, 30);
	gtk_box_pack_start(GTK_BOX(VBox), Alignment, FALSE, TRUE, 0);
	Label = gtk_label_new("Rochet Sylvain (France)");
	gtk_container_add(GTK_CONTAINER(Alignment), Label);

	/* email */
	Alignment = gtk_alignment_new(0.5, 0.0, 0.0, 0.0);
	gtk_widget_set_usize(Alignment, 0, 30);
	gtk_box_pack_start(GTK_BOX(VBox), Alignment, FALSE, TRUE, 0);
	Label = gtk_label_new("gradator@ifrance.com");
	gtk_container_add(GTK_CONTAINER(Alignment), Label);


	/* ok button */
	Alignment = gtk_alignment_new(0.5, 0.5, 0.0, 0.0);
	gtk_widget_set_usize(Alignment, 0, 50);
	gtk_box_pack_start(GTK_BOX(VBox), Alignment, FALSE, FALSE, 0);

	Button = gtk_button_new_with_label("OK");
	gtk_widget_set_usize(Button, 70, 0);
	gtk_container_add(GTK_CONTAINER(Alignment), Button);

	gtk_signal_connect(GTK_OBJECT(Button), "clicked", (GtkSignalFunc)CallBack_button_aboutwindow, AboutWin);


	gtk_widget_show_all(AboutWin);
}


/* put gameclist in correct mode for display games */
void gameclist_title_showgames()  {

	/* fields showed are:
		[0] "host"
		[1] "version"
		[2] "game"
		[3] "description"
		[4] "players"
 	   fields hided are:
		[5] "port"
		[6] "gametype"
		[7] "gameid"
	*/

	if(global->mode_gameclist != GAMECLIST_MODE_GAMELIST)  {

		gtk_clist_clear(GTK_CLIST(global->GameCList));

		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 0, "Host");
		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 1, "Version");
		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 2, "Game");
		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 3, "Description");
		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 4, "Players");

		gtk_clist_set_column_visibility(GTK_CLIST(global->GameCList), 4, TRUE);

		global->mode_gameclist = GAMECLIST_MODE_GAMELIST;

		gtk_clist_column_titles_passive(GTK_CLIST(global->GameCList));
	}
}


/* put gameclist in correct mode for display servers */
void gameclist_title_showservers()  {

	if(global->mode_gameclist != GAMECLIST_MODE_SERVERLIST)  {

		gtk_clist_clear(GTK_CLIST(global->GameCList));

		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 0, "Host");
		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 1, "Port");
		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 2, "Version");
		gtk_clist_set_column_title(GTK_CLIST(global->GameCList), 3, "Users");

		gtk_clist_set_column_visibility(GTK_CLIST(global->GameCList), 4, FALSE);

		global->mode_gameclist = GAMECLIST_MODE_SERVERLIST;

		gtk_clist_column_titles_passive(GTK_CLIST(global->GameCList));
	}
}



/* when receive event: redraw an estate */
void on_board_expose (GtkWidget *widget, GdkEventExpose *event)   {

	guchar *ptr = gtk_object_get_data(GTK_OBJECT(widget), "estateid");

	game->estate[ atoi(ptr) ].redraw = TRUE;
}

/* when receive event: redraw player token */
void on_playertoken_expose (GtkWidget *widget, GdkEventExpose *event)   {

	guchar *ptr = gtk_object_get_data(GTK_OBJECT(widget), "player");

	game->player[ atoi(ptr) ].playerlist_token_redraw = TRUE;
}

/* when receive event: redraw player cards */
void on_playercards_expose (GtkWidget *widget, GdkEventExpose *event)   {

	guchar *ptr = gtk_object_get_data(GTK_OBJECT(widget), "player");

	game->player[ atoi(ptr) ].playerlist_cards_redraw = TRUE;
}


/* when receive event: redraw logo */
void on_logo_expose (GtkWidget *widget, GdkEventExpose *event)   {

	guint32 frameid;
	gpointer draw_ptr;

	global->logo_redraw = TRUE;

	frameid = global->logo_frame;
	eng_create_frame(frameid);

	if(global->logo_redraw  ||  eng_zone_is_modified(frameid, 0, 0, data->logo_width -1, data->logo_height -1) )  {

		draw_ptr = eng_get_zone(frameid, 0, 0, data->logo_width -1, data->logo_height -1);
		gdk_draw_rgb_image (global->gdkrgb_logo->window,  global->gdkrgb_logo->style->fg_gc[GTK_STATE_NORMAL],  10,  10,  data->logo_width,  data->logo_height,  GDK_RGB_DITHER_MAX,  draw_ptr,  data->logo_width * 3);

		global->logo_redraw = FALSE;
	}	
}


/* display board */
gboolean update_display() {

	guint32 i, j, frameid;
	guint16 draw_x1, draw_y1, draw_x2, draw_y2, draw_width, draw_height;
	gpointer draw_ptr;

//	test_frequency();

	if(global->phase != PHASE_GAMEPLAY) return(TRUE);


	/* draw the board */
	frameid = game->board_frame;
	eng_create_frame(frameid);

	for(i = 0 ; i < data->number_estates ; i++)  {

		j = data->estate[i].buffer_board;

		draw_x1 = data->estate[i].x;
		draw_y1 = data->estate[i].y;
		draw_width = data->pngfile_board_width[j];
		draw_height = data->pngfile_board_height[j];
		draw_x2 = draw_x1 + draw_width -1;
		draw_y2 = draw_y1 + draw_height -1;

		if(game->estate[i].redraw  ||  eng_zone_is_modified(frameid, draw_x1, draw_y1, draw_x2, draw_y2) )  {

			draw_ptr = eng_get_zone(frameid, draw_x1, draw_y1, draw_x2, draw_y2);
			gdk_draw_rgb_image (game->estate[i].gdkrgb->window,  game->estate[i].gdkrgb->style->fg_gc[GTK_STATE_NORMAL],  0,  0,  draw_width,  draw_height,  GDK_RGB_DITHER_MAX,  draw_ptr,  draw_width * 3);

			game->estate[i].redraw = FALSE;
		}
	}


	/* draw playerlist */
	for(i = 0 ; i < MAX_PLAYERS ; i++)  {

		if(! game->player[i].playerid) continue;


		/* playerlist cards */
		frameid = game->player[i].playerlist_cards_frame;
		eng_create_frame(frameid);

		if(game->player[i].playerlist_cards_redraw  ||  eng_zone_is_modified(frameid, 0, 0, data->playerlist_cards_width -1, data->playerlist_cards_height -1) )  {

			draw_ptr = eng_get_zone(frameid, 0, 0, data->playerlist_cards_width -1, data->playerlist_cards_height -1);
			gdk_draw_rgb_image (game->player[i].playerlist_cards_gdkrgb->window,  game->player[i].playerlist_cards_gdkrgb->style->fg_gc[GTK_STATE_NORMAL],  0,  0,  data->playerlist_cards_width,  data->playerlist_cards_height,  GDK_RGB_DITHER_MAX,  draw_ptr,  data->playerlist_cards_width * 3);

			game->player[i].playerlist_cards_redraw = FALSE;
		}


		/* playerlist token */
		frameid = game->player[i].playerlist_token_frame;
		eng_create_frame(frameid);

		if(game->player[i].playerlist_token_redraw  ||  eng_zone_is_modified(frameid, 0, 0, data->playerlist_token_width -1, data->playerlist_token_height -1) )  {

			draw_ptr = eng_get_zone(frameid, 0, 0, data->playerlist_token_width -1, data->playerlist_token_height -1);
			gdk_draw_rgb_image (game->player[i].playerlist_token_gdkrgb->window,  game->player[i].playerlist_token_gdkrgb->style->fg_gc[GTK_STATE_NORMAL],  0,  0,  data->playerlist_token_width,  data->playerlist_token_height,  GDK_RGB_DITHER_MAX,  draw_ptr,  data->playerlist_token_width * 3);

			game->player[i].playerlist_token_redraw = FALSE;
		}
	}


	return(TRUE);
}


