/*
 *     gtkatlantic - the gtk+ monopd client, enjoy network monopoly games
 *
 *
 *  Copyright (C) 2002 Rochet Sylvain
 *
 *  gtkatlantic is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gtk/gtk.h>
#include <libxml/parser.h>

#define SERVER_XMLROOTELEMENT "monopd"
#define SERVER_VERSIONSTRING "%d.%d.%d"

#define METASERVER_XMLROOTELEMENT "monopigator"

#define GTKATLANTIC_WORK_WITH_MONOPD "0.6.1"

void xmlparse_getgamelist_plugger(guint32 connectid);
void xmlparse_game_plugger(guint32 connectid);

void xmlparse_server_getlist(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);
void xmlparse_server_game(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);
void xmlparse_client(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);
void xmlparse_gameupdate(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);
void xmlparse_message(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);
void xmlparse_estateupdate(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);
void xmlparse_playerupdate(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);
void xmlparse_auctionupdate(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);
void xmlparse_updateplayerlist(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);

void xmlparse_updategamelist(guint32 connectid, xmlDocPtr doc, xmlNodePtr cur);

void get_metaserver_list(guint32 connectid);
void xmlparse_metaserver(guint32 connectid);


